#include <windows.h>
#include <stdio.h>

PVOID __stdcall GetFunctionAddress(PVOID pThunkOrRealAddr);
BOOL WriteProcessMemoryEx(PVOID pTo, PVOID pFrom, ULONG cb);

int BuggyFunction(volatile int a)
{
   return a + 0x12345678; //    "return a - 0x12345678;"
}
void main()
{
    //      
    printf("Before modification: %08Xh\n", BuggyFunction(0x123));

    const int ms = 256;                     //  BuggyFunction  
                                            //  
    int i;
    LPBYTE pCode = (LPBYTE)GetFunctionAddress(&BuggyFunction);
    for (i = 0; i < ms; i++, pCode++)
    {
         if (*(DWORD *)pCode == 0x12345678)
            break;
    }

    if (i >= ms)
    {
        printf("Hmm. Instruction was not found\n");
        return;
    }

    //  
    BYTE  bSub = 0x2d;                      // sub eax, dword ptr [ebp + n]
    WriteProcessMemoryEx(pCode - 1, &bSub, sizeof(bSub));

    //      
    printf("After modification: %08Xh\n", BuggyFunction(0x123));
}
BOOL WriteProcessMemoryEx(PVOID pTo, PVOID pFrom, ULONG cb)
{
    DWORD n = 0;
    BOOL  f = WriteProcessMemory(HANDLE(-1), pTo, pFrom, cb, &n);
    if (f)
    {
        if (n != cb)
            return false;

        return true;
    }

    if (GetLastError() != ERROR_NOACCESS)
        return false;

    DWORD dwOldProtect;
    if (!VirtualProtect(pTo, cb, PAGE_WRITECOPY, &dwOldProtect))
        return false;

    f = WriteProcessMemory(HANDLE(-1), pTo, pFrom, cb, &n);
    VirtualProtect(pTo, cb, dwOldProtect, &dwOldProtect);

    if (f)
    {
        if (n != cb)
        {
            VirtualProtect(pTo, cb, dwOldProtect, &dwOldProtect);
            return false;
        }
    }

    return f;
}
bool __stdcall IsThunk(PVOID pThunk, bool *pfRel = NULL)
{
  #define CPU_JMP_MEM32   0x25FF            // JMP [mem32]
  #define CPU_JMP_NEAR    0xE9              // JMP offset32

    bool fResult = false;                   // Assume default return value

    if (pfRel)
        *pfRel = false;

    if (!IsBadReadPtr(pThunk, sizeof(WORD)))
    {
        if (*(WORD*)pThunk == CPU_JMP_MEM32)
                                            // FF 25 XXXXXXXX      JMP [mem32]
        {
            PVOID** ppFunction = (PVOID**)((BYTE*)pThunk + sizeof(WORD));
                                            // ppFunction = XXXXXXXX

            if (!IsBadReadPtr(*ppFunction,  sizeof(DWORD)) &&
                !IsBadReadPtr(**ppFunction, sizeof(DWORD)))
            {
                fResult = true;
            }
        }
        else
        if (*LPBYTE(pThunk) == CPU_JMP_NEAR)
        {
            if (pfRel)
                *pfRel = true;

            fResult = true;
        }
    }
    return fResult;
}
PVOID __stdcall GetImportedFunctionAddress(PVOID pThunk)
{
    PVOID pFunction = NULL;                 // Assume default return value

    bool  fRel;
    bool  fThunk = IsThunk(pThunk, &fRel);

    for (; fThunk; fThunk = IsThunk(pThunk, &fRel))
    {
        if (fRel)
            pThunk = LPBYTE(DWORD_PTR(pThunk) + 5 + *(DWORD *)(LPBYTE(pThunk) + 1));
        else
        {
            PVOID** ppFunction = (PVOID**)((BYTE *)pThunk + sizeof(WORD));
            pThunk             = **ppFunction;
        }
    }

    return pThunk;
}
PVOID __stdcall GetFunctionAddress(PVOID pThunkOrRealAddr)
{
    return IsThunk(pThunkOrRealAddr) ?
            GetImportedFunctionAddress(pThunkOrRealAddr) : pThunkOrRealAddr;
}
